module ShapePicture_Editor exposing (main)
--Browser
import Browser
import Browser.Navigation as Nav
-- Url
import Url
--
import Http
-- Own
import TypeHolder exposing (Model, Msg(..))
import Manager.UpdateManager exposing (update)
import Manager.ViewManager   exposing (documentView)
import Manager.StateManager  as StM
import Util.Util exposing (QueryInfo, JsonFile, getQueryInfo)

main = Browser.application
        { init = init
        , subscriptions = subscriptions
        , update = update
        , view = documentView
        , onUrlChange = UrlChanged
        , onUrlRequest = LinkClicked
        }
-- INIT
init : () -> Url.Url -> Nav.Key-> (Model, Cmd Msg)
init _ url key =
    let queryInfo = getQueryInfo url
    in
     ({ state = StM.Standby
      , saved = []
      , svgShapeHover = 0
      , httpLoadResult = (Ok " Init")
      , picture = Nothing
      , queryInfo = queryInfo
      , jsonFile = { text  = "", error = "" }
      , url  = url
      , key  = key
      }
     , case queryInfo.jsonUrl of
         Just jsonUrl -> Http.get { url = Url.toString jsonUrl
                                  , expect = Http.expectString ShapePictureJsonStringLoaded
                                  }
         Nothing -> Cmd.none

     )
-- SUBSCRIPTIONS
subscriptions : Model -> Sub Msg
subscriptions model = Sub.none